## mandos 1.7.1

=== Makefile ===
WARN=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
	-Wunused -Wuninitialized -Wstrict-overflow=5 \
	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
	-Wsuggest-attribute=noreturn -Wfloat-equal -Wundef -Wshadow \
	-Wunsafe-loop-optimizations -Wpointer-arith \
	-Wbad-function-cast -Wcast-qual -Wcast-align -Wwrite-strings \
	-Wconversion -Wlogical-op -Waggregate-return \
	-Wstrict-prototypes -Wold-style-definition \
	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
	-Wredundant-decls -Wnested-externs -Winline -Wvla \
	-Wvolatile-register-var -Woverlength-strings
#DEBUG=-ggdb3
# For info about _FORTIFY_SOURCE, see feature_test_macros(7)
# and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
LINK_FORTIFY_LD=-z relro -z now
LINK_FORTIFY=

# If BROKEN_PIE is set, do not build with -pie
ifndef BROKEN_PIE
FORTIFY += -fPIE
LINK_FORTIFY += -pie
endif
#COVERAGE=--coverage
OPTIMIZE=-Os -fno-strict-aliasing
LANGUAGE=-std=gnu11
htmldir=man
version=1.7.1
SED=sed

USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nobody || echo 65534)))

## Use these settings for a traditional /usr/local install
# PREFIX=$(DESTDIR)/usr/local
# CONFDIR=$(DESTDIR)/etc/mandos
# KEYDIR=$(DESTDIR)/etc/mandos/keys
# MANDIR=$(PREFIX)/man
# INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
# STATEDIR=$(DESTDIR)/var/lib/mandos
# LIBDIR=$(PREFIX)/lib
##

## These settings are for a package-type install
PREFIX=$(DESTDIR)/usr
CONFDIR=$(DESTDIR)/etc/mandos
KEYDIR=$(DESTDIR)/etc/keys/mandos
MANDIR=$(PREFIX)/share/man
INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
STATEDIR=$(DESTDIR)/var/lib/mandos
LIBDIR=$(shell \
	for d in \
	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
		if [ -d "$$d" -a "$$d" = "$${d%/}" ]; then \
			echo "$(DESTDIR)$$d"; \
			break; \
		fi; \
	done)
##

SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)

GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
AVAHI_LIBS=$(shell pkg-config --libs avahi-core)
GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
	getconf LFS_LDFLAGS)
LIBNL3_CFLAGS=$(shell pkg-config --cflags-only-I libnl-route-3.0)
LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)

# Do not change these two
CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
	-DVERSION='"$(version)"'
LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))

# Commands to format a DocBook <refentry> document into a manual page
DOCBOOKTOMAN=$(strip cd $(dir $<); xsltproc --nonet --xinclude \
	--param man.charmap.use.subset		0 \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	/usr/share/xml/docbook/stylesheet/nwalsh/manpages/docbook.xsl \
	$(notdir $<); \
	if locale --all 2>/dev/null | grep --regexp='^en_US\.utf8$$' \
	&& type man 2>/dev/null; then LANG=en_US.UTF-8 MANWIDTH=80 \
	man --warnings --encoding=UTF-8 --local-file $(notdir $@); \
	fi >/dev/null)

DOCBOOKTOHTML=$(strip xsltproc --nonet --xinclude \
	--param make.year.ranges		1 \
	--param make.single.year.ranges		1 \
	--param man.output.quietly		1 \
	--param man.authors.section.enabled	0 \
	--param citerefentry.link		1 \
	--output $@ \
	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
	$<; $(HTMLPOST) $@)
# Fix citerefentry links
HTMLPOST=$(SED) --in-place \
	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'

PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
	plugins.d/plymouth
PLUGIN_HELPERS=plugin-helpers/mandos-client-iprouteadddel
CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
	plugins.d/mandos-client.8mandos \
	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
	plugins.d/plymouth.8mandos intro.8mandos

htmldocs=$(addsuffix .xhtml,$(DOCS))

objects=$(addsuffix .o,$(CPROGS))

all: $(PROGS) mandos.lsm

doc: $(DOCS)

html: $(htmldocs)

%.5: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.5.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

%.8mandos: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
%.8mandos.xhtml: %.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

intro.8mandos: intro.xml common.ent legalnotice.xml
	$(DOCBOOKTOMAN)
intro.8mandos.xhtml: intro.xml common.ent legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.8: mandos.xml common.ent mandos-options.xml overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.8.xhtml: mandos.xml common.ent mandos-options.xml \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-keygen.8: mandos-keygen.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-keygen.8.xhtml: mandos-keygen.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-monitor.8: mandos-monitor.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-monitor.8.xhtml: mandos-monitor.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos-ctl.8: mandos-ctl.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos-ctl.8.xhtml: mandos-ctl.xml common.ent overview.xml \
		 legalnotice.xml
	$(DOCBOOKTOHTML)

mandos.conf.5: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
mandos.conf.5.xhtml: mandos.conf.xml common.ent mandos-options.xml \
		legalnotice.xml
	$(DOCBOOKTOHTML)

plugin-runner.8mandos: plugin-runner.xml common.ent overview.xml \
		legalnotice.xml
	$(DOCBOOKTOMAN)
plugin-runner.8mandos.xhtml: plugin-runner.xml common.ent \
		overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

plugins.d/mandos-client.8mandos: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOMAN)
plugins.d/mandos-client.8mandos.xhtml: plugins.d/mandos-client.xml \
					common.ent \
					mandos-options.xml \
					overview.xml legalnotice.xml
	$(DOCBOOKTOHTML)

# Update all these files with version number $(version)
common.ent: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(<!ENTITY version "\)[^"]*">$$/\1$(version)">/' \
		$@)

mandos: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-keygen: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(VERSION="\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-ctl: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos-monitor: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(version = "\)[^"]*"$$/\1$(version)"/' \
		$@)

mandos.lsm: Makefile
	$(strip $(SED) --in-place \
		--expression='s/^\(Version:\).*/\1\t$(version)/' \
		$@)
	$(strip $(SED) --in-place \
		--expression='s/^\(Entered-date:\).*/\1\t$(shell date --rfc-3339=date --reference=Makefile)/' \
		$@)
	$(strip $(SED) --in-place \
		--expression='s/\(mandos_\)[0-9.]\+\(\.orig\.tar\.gz\)/\1$(version)\2/' \
		$@)

plugins.d/mandos-client: plugins.d/mandos-client.c
	$(LINK.c) $^ -lrt $(GNUTLS_LIBS) $(AVAHI_LIBS) $(strip\
		) $(GPGME_LIBS) $(LOADLIBES) $(LDLIBS) -o $@

plugin-helpers/mandos-client-iprouteadddel: plugin-helpers/mandos-client-iprouteadddel.c
	$(LINK.c) $(LIBNL3_CFLAGS) $^ $(LIBNL3_LIBS) $(strip\
		) $(LOADLIBES) $(LDLIBS) -o $@

.PHONY : all doc html clean distclean mostlyclean maintainer-clean \
	check run-client run-server install install-html \
	install-server install-client-nokey install-client uninstall \
	uninstall-server uninstall-client purge purge-server \
	purge-client

clean:
	-rm --force $(CPROGS) $(objects) $(htmldocs) $(DOCS) core

distclean: clean
mostlyclean: clean
maintainer-clean: clean
	-rm --force --recursive keydir confdir statedir

check:	all
	./mandos --check
	./mandos-ctl --check

# Run the client with a local config and key
run-client: all keydir/seckey.txt keydir/pubkey.txt
	@echo "###################################################################"
	@echo "# The following error messages are harmless and can be safely     #"
	@echo "# ignored.  The messages are caused by not running as root, but   #"
	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
	@echo "# From plugin-runner: setgid: Operation not permitted             #"
	@echo "#                     setuid: Operation not permitted             #"
	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
	@echo "# From mandos-client:                                             #"
	@echo "#             Failed to raise privileges: Operation not permitted #"
	@echo "#             Warning: network hook \"*\" exited with status *      #"
	@echo "###################################################################"
# We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
	./plugin-runner --plugin-dir=plugins.d \
		--plugin-helper-dir=plugin-helpers \
		--config-file=plugin-runner.conf \
		--options-for=mandos-client:--seckey=keydir/seckey.txt,--pubkey=keydir/pubkey.txt,--network-hook-dir=network-hooks.d \
		--env-for=mandos-client:GNOME_KEYRING_CONTROL= \
		$(CLIENTARGS)

# Used by run-client
keydir/seckey.txt keydir/pubkey.txt: mandos-keygen
	install --directory keydir
	./mandos-keygen --dir keydir --force

# Run the server with a local config
run-server: confdir/mandos.conf confdir/clients.conf statedir
	./mandos --debug --no-dbus --configdir=confdir \
		--statedir=statedir $(SERVERARGS)

# Used by run-server
confdir/mandos.conf: mandos.conf
	install --directory confdir
	install --mode=u=rw,go=r $^ $@
confdir/clients.conf: clients.conf keydir/seckey.txt
	install --directory confdir
	install --mode=u=rw $< $@
# Add a client password
	./mandos-keygen --dir keydir --password --no-ssh >> $@
statedir:
	install --directory statedir

install: install-server install-client-nokey

install-html: html
	install --directory $(htmldir)
	install --mode=u=rw,go=r --target-directory=$(htmldir) \
		$(htmldocs)

install-server: doc
	install --directory $(CONFDIR)
	if install --directory --mode=u=rwx --owner=$(USER) \
		--group=$(GROUP) $(STATEDIR); then \
		:; \
	elif install --directory --mode=u=rwx $(STATEDIR); then \
		chown -- $(USER):$(GROUP) $(STATEDIR) || :; \
	fi
	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
		mandos-ctl
	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
		mandos-monitor
	install --mode=u=rw,go=r --target-directory=$(CONFDIR) \
		mandos.conf
	install --mode=u=rw --target-directory=$(CONFDIR) \
		clients.conf
	install --mode=u=rw,go=r dbus-mandos.conf \
		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
	install --mode=u=rwx,go=rx init.d-mandos \
		$(DESTDIR)/etc/init.d/mandos
	if [ "$(SYSTEMD)" != "$(DESTDIR)" -a -d "$(SYSTEMD)" ]; then \
		install --mode=u=rw,go=r mandos.service $(SYSTEMD); \
	fi
	install --mode=u=rw,go=r default-mandos \
		$(DESTDIR)/etc/default/mandos

=== debian/changelog ===
mandos (1.7.1-2build1) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:26:29 +0000

mandos (1.7.1-2) unstable; urgency=medium

  * debian/control (Package: mandos/Depends): Fix "Please drop versioned
    dependency on initscripts package" by removing initscripts dependency
    (Closes: #804967)
  * debian/rules (override_dh_fixperms) Fix "FTBFS when built with
    dpkg-buildpackage -A (No such file or directory)" by splitting into
    "override_dh_fixperms-arch" and "override_dh_fixperms-indep".
    (Closes: #806073)

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 05 Dec 2015 02:27:40 +0100

mandos (1.7.1-1) unstable; urgency=medium

  * New upstream release.

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 24 Oct 2015 19:43:40 +0200

=== debian/control ===
Source: mandos
Section: admin
Priority: extra
Maintainer: Mandos Maintainers <mandos@recompile.se>
Uploaders: Teddy Hogeborn <teddy@recompile.se>,
	   Björn Påhlsson <belorn@recompile.se>
Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
	| gnutls-dev, xsltproc, pkg-config, libnl-route-3-dev
Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
	python2.7-dbus, python2.7-avahi, python2.7-gobject
Standards-Version: 3.9.6
Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
Homepage: http://www.recompile.se/mandos

Package: mandos
Architecture: all
Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
	python2.7-avahi, python-gobject, python2.7-gobject,
	avahi-daemon, adduser, python-urwid, python2.7-urwid,
	gnupg (<< 2)
Recommends: ssh-client | fping
Description: server giving encrypted passwords to Mandos clients
 This is the server part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using an OpenPGP
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using the same OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

Package: mandos-client
Architecture: linux-any
Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
Recommends: ssh, gnutls-bin | openssl
Breaks: dropbear (<= 0.53.1-1)
Enhances: cryptsetup
Description: do unattended reboots with an encrypted root file system
 This is the client part of the Mandos system, which allows
 computers to have encrypted root file systems and at the
 same time be capable of remote and/or unattended reboots.
 .
 The computers run a small client program in the initial RAM
 disk environment which will communicate with a server over a
 network.  All network communication is encrypted using TLS.
 The clients are identified by the server using an OpenPGP
 key; each client has one unique to it.  The server sends the
 clients an encrypted password.  The encrypted password is
 decrypted by the clients using the same OpenPGP key, and the
 password is then used to unlock the root file system,
 whereupon the computers can continue booting normally.

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_build-arch:
	LC_ALL=en_US.utf8 dh_auto_build -- all doc

override_dh_auto_build-indep:
	LC_ALL=en_US.utf8 dh_auto_build -- doc

override_dh_installinit-indep:
	dh_installinit --onlyscripts \
		--update-rcd-params="defaults 25 15"

override_dh_auto_install-indep:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos install-server

override_dh_auto_install-arch:
	$(MAKE) DESTDIR=$(CURDIR)/debian/mandos-client \
		install-client-nokey

override_dh_fixperms-arch:
	dh_fixperms --exclude etc/keys/mandos \
		--exclude etc/mandos/plugins.d \
		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
	chmod --recursive g-w -- \
	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"

override_dh_fixperms-indep:
	dh_fixperms --exclude etc/mandos/clients.conf

override_dh_auto_test-arch: ;

=== debian/watch ===
version=3
opts=pgpsigurlmangle=s/$/.asc/ \
 ftp://ftp.recompile.se/pub/mandos/mandos[-_]([^\s]+?)(?:\.orig)?\.tar\.(?:gz|bz2|7z|xz)

## mandos 1.7.7

=== Makefile ===
--- 
+++ 
@@ -14,6 +14,20 @@
 # For info about _FORTIFY_SOURCE, see feature_test_macros(7)
 # and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+# <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
+ALL_SANITIZE_OPTIONS:=-fsanitize=address -fsanitize=undefined \
+        -fsanitize=shift -fsanitize=integer-divide-by-zero \
+        -fsanitize=unreachable -fsanitize=vla-bound -fsanitize=null \
+        -fsanitize=return -fsanitize=signed-integer-overflow \
+        -fsanitize=bounds -fsanitize=alignment \
+        -fsanitize=object-size -fsanitize=float-divide-by-zero \
+        -fsanitize=float-cast-overflow -fsanitize=nonnull-attribute \
+        -fsanitize=returns-nonnull-attribute -fsanitize=bool \
+        -fsanitize=enum
+# Check which sanitizing options can be used
+SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
+	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
+	-o /dev/null >/dev/null 2>&1 && echo $(option)))
 LINK_FORTIFY_LD=-z relro -z now
 LINK_FORTIFY=
 
@@ -26,11 +40,11 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.1
+version=1.7.7
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nobody || echo 65534)))
+GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
 
 ## Use these settings for a traditional /usr/local install
 # PREFIX=$(DESTDIR)/usr/local
@@ -61,6 +75,7 @@
 ##
 
 SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
+TMPFILES=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
 
 GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
 GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
@@ -73,9 +88,9 @@
 LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)
 
 # Do not change these two
-CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(COVERAGE) $(OPTIMIZE) \
-	$(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) $(GPGME_CFLAGS) \
-	-DVERSION='"$(version)"'
+CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
+	$(OPTIMIZE) $(LANGUAGE) $(GNUTLS_CFLAGS) $(AVAHI_CFLAGS) \
+	$(GPGME_CFLAGS) -DVERSION='"$(version)"'
 LDFLAGS+=-Xlinker --as-needed $(COVERAGE) $(LINK_FORTIFY) $(foreach flag,$(LINK_FORTIFY_LD),-Xlinker $(flag))
 
 # Commands to format a DocBook <refentry> document into a manual page
@@ -317,27 +332,3 @@
 
 install-server: doc
 	install --directory $(CONFDIR)
-	if install --directory --mode=u=rwx --owner=$(USER) \
-		--group=$(GROUP) $(STATEDIR); then \
-		:; \
-	elif install --directory --mode=u=rwx $(STATEDIR); then \
-		chown -- $(USER):$(GROUP) $(STATEDIR) || :; \
-	fi
-	install --mode=u=rwx,go=rx mandos $(PREFIX)/sbin/mandos
-	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
-		mandos-ctl
-	install --mode=u=rwx,go=rx --target-directory=$(PREFIX)/sbin \
-		mandos-monitor
-	install --mode=u=rw,go=r --target-directory=$(CONFDIR) \
-		mandos.conf
-	install --mode=u=rw --target-directory=$(CONFDIR) \
-		clients.conf
-	install --mode=u=rw,go=r dbus-mandos.conf \
-		$(DESTDIR)/etc/dbus-1/system.d/mandos.conf
-	install --mode=u=rwx,go=rx init.d-mandos \
-		$(DESTDIR)/etc/init.d/mandos
-	if [ "$(SYSTEMD)" != "$(DESTDIR)" -a -d "$(SYSTEMD)" ]; then \
-		install --mode=u=rw,go=r mandos.service $(SYSTEMD); \
-	fi
-	install --mode=u=rw,go=r default-mandos \
-		$(DESTDIR)/etc/default/mandos

=== debian/changelog ===
mandos (1.7.7-1) unstable; urgency=medium

  * New upstream release.
  * debian/mandos-client.postinst (configure): If older version, fix
    permissions on plugin helper directory.  Also fix permissions on
    plugin helper local override directory (/etc/mandos/plugin-helpers),
    but only if not listed by "dpkg-statoverride".
  * debian/rules (override_dh_fixperms-arch): Exclude plugin helper
    directory from dh_fixperms.
  * debian/mandos.postinst (configure): Fix state directory permissions,
    but only if not listed by "dpkg-statoverride".
  * debian/mandos-client.lintian-overrides: Do not warn about permissions
    on plugin helper directory.
  * debian/mandos.dirs (usr/lib/tmpfiles.d): Added.

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 19 Mar 2016 22:58:49 +0100

mandos (1.7.6-1) unstable; urgency=medium

  * New upstream release.
  * debian/control (Source: mandos/Build-Depends-Indep): Remove
    "python-avahi".
    (Source: mandos/Build-Depends-Indep): Change "python-gi |
    python-gobject" to "python-gi"; i.e. remove "python-gobject".

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 13 Mar 2016 22:58:23 +0100

mandos (1.7.5-1) unstable; urgency=high

  * New upstream release.
  * debian/mandos.postinst (configure): If old version was 1.7.4-1 or
    1.7.4-1~bpo8+1, fix situation where clients.pickle file is owned by
    root.

 -- Teddy Hogeborn <teddy@recompile.se>  Tue, 08 Mar 2016 01:09:55 +0100

mandos (1.7.4-1) unstable; urgency=medium

  * New upstream release.
  * initramfs-tools-script: Fix "Call to configure_network in initramfs
    script broken due to set -e" by surrounding call by "set +x" and "set
    -e" (Closes: #816513)
  * debian/control: (Source: mandos/Build-Depends-Indep): Change
    "python-gobject | python-gi" to "python-gi | python-gobject"
    (Package: mandos/Depends): - '' -

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 05 Mar 2016 23:10:07 +0100

mandos (1.7.3-1) unstable; urgency=medium

  * New upstream release.

 -- Teddy Hogeborn <teddy@recompile.se>  Mon, 29 Feb 2016 22:26:38 +0100

mandos (1.7.2-1) unstable; urgency=medium

  * New upstream release.
  * Fix "Uses unneeded and obsolete version specific python packages"
    by removing version-specific dependencies (Closes: #811159)
  * debian/control (Source: mandos/Build-Depends): Add (>= 3.3.0) to
    "libgnutls28-dev" and "gnutls-dev".
    (Source: mandos/Build-Depends-Indep): Remove "python2.7-gnutls",
    "python2.7", "python2.7-dbus", "python2.7-avahi", and
    "python2.7-gobject"; replace with "python (>= 2.7), python (<< 3)",
    "python-dbus", "python-avahi", "python-gobject | python-gi".
    (Package: mandos/Depends): Remove "python-gnutls" and
    "python2.7-gnutls", add "libgnutls28-dev (>= 3.3.0) | libgnutls30 (>=
    3.3.0)".  Add "python (<< 3)".  Remove "python2.7-dbus",
    "python2.7-avahi", "python2.7-gobject", and "python2.7-urwid".
    Replace "python-gobject" with "python-gobject | python-gi" and "gnupg
    (<< 2)" with "gnupg".
    (Package: mandos-client/Depends): Replace
    "gnupg (<< 2)" with "gnupg".
    (Source: mandos/Standards-Version): Change to 3.9.7.
  * debian/copyright (Copyright): Update copyright year.

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 28 Feb 2016 16:09:01 +0100

=== debian/control ===
--- 
+++ 
@@ -5,22 +5,22 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev
-	| gnutls-dev, xsltproc, pkg-config, libnl-route-3-dev
-Build-Depends-Indep: systemd, python2.7, python2.7-gnutls,
-	python2.7-dbus, python2.7-avahi, python2.7-gobject
-Standards-Version: 3.9.6
+	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev (>= 3.3.0)
+	| gnutls-dev (>= 3.3.0), xsltproc, pkg-config,
+	libnl-route-3-dev
+Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
+	python-dbus, python-gi
+Standards-Version: 3.9.7
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: http://www.recompile.se/mandos
 
 Package: mandos
 Architecture: all
-Depends: ${misc:Depends}, python (>= 2.7), python2.7, python-gnutls,
-	python2.7-gnutls, python-dbus, python2.7-dbus, python-avahi,
-	python2.7-avahi, python-gobject, python2.7-gobject,
-	avahi-daemon, adduser, python-urwid, python2.7-urwid,
-	gnupg (<< 2)
+Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
+	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
+	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
+	gnupg
 Recommends: ssh-client | fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows
@@ -40,7 +40,7 @@
 Package: mandos-client
 Architecture: linux-any
 Depends: ${shlibs:Depends}, ${misc:Depends}, adduser, cryptsetup,
-	gnupg (<< 2), initramfs-tools, dpkg-dev (>=1.16.0)
+	initramfs-tools, dpkg-dev (>=1.16.0)
 Recommends: ssh, gnutls-bin | openssl
 Breaks: dropbear (<= 0.53.1-1)
 Enhances: cryptsetup

## mandos 1.7.8

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.7
+version=1.7.8
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

## mandos 1.7.9

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.8
+version=1.7.9
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.9-1) unstable; urgency=medium

  * New upstream release.

 -- Teddy Hogeborn <teddy@recompile.se>  Wed, 22 Jun 2016 07:30:12 +0200

mandos (1.7.8-1) unstable; urgency=medium

  * New upstream release.
  * Fix "bad gpgme_op_decrypt: GPGME: Decryption failed." by copying
    /usr/bin/gpg-agent into initramfs (Closes: #819982)
  * debian/control (Homepage): Change URL to use HTTPS.
    (Standards-Version): Update to 3.9.8.
  * debian/copyright (Source): Change URL to HTTPS.
  * debian/mandos-client.README.Debian: Change wording to match updated
    capabilities.

 -- Teddy Hogeborn <teddy@recompile.se>  Tue, 21 Jun 2016 21:36:10 +0200

=== debian/control ===
--- 
+++ 
@@ -10,10 +10,10 @@
 	libnl-route-3-dev
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
-Homepage: http://www.recompile.se/mandos
+Homepage: https://www.recompile.se/mandos
 
 Package: mandos
 Architecture: all

=== debian/rules ===
--- 
+++ 
@@ -23,6 +23,7 @@
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/plugins.d \
 		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
+		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
 	chmod --recursive g-w -- \
 	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"

## mandos 1.7.10

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.9
+version=1.7.10
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

## mandos 1.7.11

=== Makefile ===
--- 
+++ 
@@ -10,12 +10,12 @@
 	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
 	-Wredundant-decls -Wnested-externs -Winline -Wvla \
 	-Wvolatile-register-var -Woverlength-strings
-#DEBUG=-ggdb3
+#DEBUG=-ggdb3 -fsanitize=address 
 # For info about _FORTIFY_SOURCE, see feature_test_macros(7)
-# and <http://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
+# and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
 FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 # <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
-ALL_SANITIZE_OPTIONS:=-fsanitize=address -fsanitize=undefined \
+ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
         -fsanitize=shift -fsanitize=integer-divide-by-zero \
         -fsanitize=unreachable -fsanitize=vla-bound -fsanitize=null \
         -fsanitize=return -fsanitize=signed-integer-overflow \
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.10
+version=1.7.11
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.11-1) unstable; urgency=high

  * New upstream release.
  * debian/control (Source: mandos/Vcs-Bzr): Change to use HTTPS.
    (Vcs-Browser): - '' -

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 01 Oct 2016 16:20:48 +0200

mandos (1.7.10-1) unstable; urgency=high

  * New upstream release.
  * debian/rules (override_dh_fixperms-arch): Also exclude
    "etc/mandos/plugin-helpers" from changes by dh_fixperms.
  * debian/mandos-client.postinst: Fix the permissions of
    "/etc/mandos/plugin-helpers" for those systems which had a fresh
    install of an older version.

 -- Teddy Hogeborn <teddy@recompile.se>  Thu, 23 Jun 2016 22:00:29 +0200

## mandos 1.7.12

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.11
+version=1.7.12
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.12-1) unstable; urgency=medium

  * New upstream release.

 -- Teddy Hogeborn <teddy@recompile.se>  Wed, 05 Oct 2016 22:06:55 +0200

=== debian/control ===
--- 
+++ 
@@ -11,8 +11,8 @@
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
 Standards-Version: 3.9.8
-Vcs-Bzr: http://ftp.recompile.se/pub/mandos/trunk
-Vcs-Browser: http://bzr.recompile.se/loggerhead/mandos/trunk/files
+Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
+Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: https://www.recompile.se/mandos
 
 Package: mandos

## mandos 1.7.13

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.12
+version=1.7.13
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.13-1) unstable; urgency=medium

  * New upstream release.
  * Fix "fails to install noninteractively" by using the "%no-protection"
    statement in the GnuPG batch parameter file. (Closes: #840001)

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 08 Oct 2016 06:31:07 +0200

## mandos 1.7.14

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.13
+version=1.7.14
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
@@ -283,15 +283,17 @@
 run-client: all keydir/seckey.txt keydir/pubkey.txt
 	@echo "###################################################################"
 	@echo "# The following error messages are harmless and can be safely     #"
-	@echo "# ignored.  The messages are caused by not running as root, but   #"
-	@echo "# you should NOT run \"make run-client\" as root unless you also    #"
-	@echo "# unpacked and compiled Mandos as root, which is NOT recommended. #"
+	@echo "# ignored:                                                        #"
 	@echo "# From plugin-runner: setgid: Operation not permitted             #"
 	@echo "#                     setuid: Operation not permitted             #"
 	@echo "# From askpass-fifo:  mkfifo: Permission denied                   #"
 	@echo "# From mandos-client:                                             #"
 	@echo "#             Failed to raise privileges: Operation not permitted #"
 	@echo "#             Warning: network hook \"*\" exited with status *      #"
+	@echo "#                                                                 #"
+	@echo "# (The messages are caused by not running as root, but you should #"
+	@echo "# NOT run \"make run-client\" as root unless you also unpacked and  #"
+	@echo "# compiled Mandos as root, which is also NOT recommended.)        #"
 	@echo "###################################################################"
 # We set GNOME_KEYRING_CONTROL to block pam_gnome_keyring
 	./plugin-runner --plugin-dir=plugins.d \
@@ -326,9 +328,3 @@
 install: install-server install-client-nokey
 
 install-html: html
-	install --directory $(htmldir)
-	install --mode=u=rw,go=r --target-directory=$(htmldir) \
-		$(htmldocs)
-
-install-server: doc
-	install --directory $(CONFDIR)

=== debian/changelog ===
mandos (1.7.14-1) unstable; urgency=medium

  * New upstream release.
  * debian/mandos-client.postinst (create_key): Stop GPG agent after
    running mandos-keygen.
  * debian/control (Package: mandos/Depends): Add "systemd-sysv | lsb-base
    (>= 3.0-6)", change "gnupg" to "gnupg2 | gnupg", and change
    "libgpgme11-dev" to "libgpgme-dev | libgpgme11-dev".

 -- Teddy Hogeborn <teddy@recompile.se>  Wed, 25 Jan 2017 20:36:03 +0100

## mandos 1.7.15

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.14
+version=1.7.15
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.15-1) unstable; urgency=medium

  * New upstream release.
  * Upstream release fixes "Seems not to be honoring zeroconf option at
    mandos.conf" (Closes: #855589)
  * debian/mandos.lintian-overrides (mandos): Add new line
    "init.d-script-needs-depends-on-lsb-base etc/init.d/mandos (line 49)".
  * debian/copyright: Update copyright year to 2017.

 -- Teddy Hogeborn <teddy@recompile.se>  Thu, 23 Feb 2017 21:29:36 +0100

=== debian/control ===
--- 
+++ 
@@ -5,9 +5,9 @@
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
 Build-Depends: debhelper (>= 9), docbook-xml, docbook-xsl,
-	libavahi-core-dev, libgpgme11-dev, libgnutls28-dev (>= 3.3.0)
-	| gnutls-dev (>= 3.3.0), xsltproc, pkg-config,
-	libnl-route-3-dev
+	libavahi-core-dev, libgpgme-dev | libgpgme11-dev,
+	libgnutls28-dev (>= 3.3.0) | gnutls-dev (>= 3.3.0),
+	xsltproc, pkg-config, libnl-route-3-dev
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
 Standards-Version: 3.9.8
@@ -20,7 +20,7 @@
 Depends: ${misc:Depends}, python (>= 2.7), python (<< 3),
 	libgnutls28-dev (>= 3.3.0) | libgnutls30 (>= 3.3.0),
 	python-dbus, python-gi, avahi-daemon, adduser, python-urwid,
-	gnupg
+	gnupg2 | gnupg, systemd-sysv | lsb-base (>= 3.0-6)
 Recommends: ssh-client | fping
 Description: server giving encrypted passwords to Mandos clients
  This is the server part of the Mandos system, which allows

=== debian/rules ===
--- 
+++ 
@@ -22,6 +22,7 @@
 override_dh_fixperms-arch:
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/plugins.d \
+		--exclude etc/mandos/plugin-helpers \
 		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
 		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d

## mandos 1.7.16

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE=-Os -fno-strict-aliasing
 LANGUAGE=-std=gnu11
 htmldir=man
-version=1.7.15
+version=1.7.16
 SED=sed
 
 USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.16-1) unstable; urgency=medium

  * New upstream release.
  * debian/copyright (License): Use program name explicitly.
    (Format): Use https in URL.
  * debian/control (Priority): Change from "extra" to "optional".
    (Standards-Version): Update to "4.0.1".

 -- Teddy Hogeborn <teddy@recompile.se>  Sun, 20 Aug 2017 21:05:26 +0200

=== debian/control ===
--- 
+++ 
@@ -1,6 +1,6 @@
 Source: mandos
 Section: admin
-Priority: extra
+Priority: optional
 Maintainer: Mandos Maintainers <mandos@recompile.se>
 Uploaders: Teddy Hogeborn <teddy@recompile.se>,
 	   Björn Påhlsson <belorn@recompile.se>
@@ -10,7 +10,7 @@
 	xsltproc, pkg-config, libnl-route-3-dev
 Build-Depends-Indep: systemd, python (>= 2.7), python (<< 3),
 	python-dbus, python-gi
-Standards-Version: 3.9.8
+Standards-Version: 4.0.1
 Vcs-Bzr: https://ftp.recompile.se/pub/mandos/trunk
 Vcs-Browser: https://bzr.recompile.se/loggerhead/mandos/trunk/files
 Homepage: https://www.recompile.se/mandos

## mandos 1.7.17

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-WARN=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
+WARN:=-O -Wall -Wextra -Wdouble-promotion -Wformat=2 -Winit-self \
 	-Wmissing-include-dirs -Wswitch-default -Wswitch-enum \
 	-Wunused -Wuninitialized -Wstrict-overflow=5 \
 	-Wsuggest-attribute=pure -Wsuggest-attribute=const \
@@ -10,10 +10,10 @@
 	-Wmissing-format-attribute -Wnormalized=nfc -Wpacked \
 	-Wredundant-decls -Wnested-externs -Winline -Wvla \
 	-Wvolatile-register-var -Woverlength-strings
-#DEBUG=-ggdb3 -fsanitize=address 
+#DEBUG:=-ggdb3 -fsanitize=address 
 # For info about _FORTIFY_SOURCE, see feature_test_macros(7)
 # and <https://gcc.gnu.org/ml/gcc-patches/2004-09/msg02055.html>.
-FORTIFY=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
+FORTIFY:=-D_FORTIFY_SOURCE=2 -fstack-protector-all -fPIC
 # <https://developerblog.redhat.com/2014/10/16/gcc-undefined-behavior-sanitizer-ubsan/>
 ALL_SANITIZE_OPTIONS:=-fsanitize=leak -fsanitize=undefined \
         -fsanitize=shift -fsanitize=integer-divide-by-zero \
@@ -28,8 +28,8 @@
 SANITIZE:=$(foreach option,$(ALL_SANITIZE_OPTIONS),$(shell \
 	echo 'int main(){}' | $(CC) --language=c $(option) /dev/stdin \
 	-o /dev/null >/dev/null 2>&1 && echo $(option)))
-LINK_FORTIFY_LD=-z relro -z now
-LINK_FORTIFY=
+LINK_FORTIFY_LD:=-z relro -z now
+LINK_FORTIFY:=
 
 # If BROKEN_PIE is set, do not build with -pie
 ifndef BROKEN_PIE
@@ -37,33 +37,33 @@
 LINK_FORTIFY += -pie
 endif
 #COVERAGE=--coverage
-OPTIMIZE=-Os -fno-strict-aliasing
-LANGUAGE=-std=gnu11
-htmldir=man
-version=1.7.16
-SED=sed
-
-USER=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
-GROUP=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
+OPTIMIZE:=-Os -fno-strict-aliasing
+LANGUAGE:=-std=gnu11
+htmldir:=man
+version:=1.7.17
+SED:=sed
+
+USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))
+GROUP:=$(firstword $(subst :, ,$(shell getent group _mandos || getent group nogroup || echo 65534)))
 
 ## Use these settings for a traditional /usr/local install
-# PREFIX=$(DESTDIR)/usr/local
-# CONFDIR=$(DESTDIR)/etc/mandos
-# KEYDIR=$(DESTDIR)/etc/mandos/keys
-# MANDIR=$(PREFIX)/man
-# INITRAMFSTOOLS=$(DESTDIR)/etc/initramfs-tools
-# STATEDIR=$(DESTDIR)/var/lib/mandos
-# LIBDIR=$(PREFIX)/lib
+# PREFIX:=$(DESTDIR)/usr/local
+# CONFDIR:=$(DESTDIR)/etc/mandos
+# KEYDIR:=$(DESTDIR)/etc/mandos/keys
+# MANDIR:=$(PREFIX)/man
+# INITRAMFSTOOLS:=$(DESTDIR)/etc/initramfs-tools
+# STATEDIR:=$(DESTDIR)/var/lib/mandos
+# LIBDIR:=$(PREFIX)/lib
 ##
 
 ## These settings are for a package-type install
-PREFIX=$(DESTDIR)/usr
-CONFDIR=$(DESTDIR)/etc/mandos
-KEYDIR=$(DESTDIR)/etc/keys/mandos
-MANDIR=$(PREFIX)/share/man
-INITRAMFSTOOLS=$(DESTDIR)/usr/share/initramfs-tools
-STATEDIR=$(DESTDIR)/var/lib/mandos
-LIBDIR=$(shell \
+PREFIX:=$(DESTDIR)/usr
+CONFDIR:=$(DESTDIR)/etc/mandos
+KEYDIR:=$(DESTDIR)/etc/keys/mandos
+MANDIR:=$(PREFIX)/share/man
+INITRAMFSTOOLS:=$(DESTDIR)/usr/share/initramfs-tools
+STATEDIR:=$(DESTDIR)/var/lib/mandos
+LIBDIR:=$(shell \
 	for d in \
 	"/usr/lib/`dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null`" \
 	"`rpm --eval='%{_libdir}' 2>/dev/null`" /usr/lib; do \
@@ -74,18 +74,18 @@
 	done)
 ##
 
-SYSTEMD=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
-TMPFILES=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
-
-GNUTLS_CFLAGS=$(shell pkg-config --cflags-only-I gnutls)
-GNUTLS_LIBS=$(shell pkg-config --libs gnutls)
-AVAHI_CFLAGS=$(shell pkg-config --cflags-only-I avahi-core)
-AVAHI_LIBS=$(shell pkg-config --libs avahi-core)
-GPGME_CFLAGS=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
-GPGME_LIBS=$(shell gpgme-config --libs; getconf LFS_LIBS; \
+SYSTEMD:=$(DESTDIR)$(shell pkg-config systemd --variable=systemdsystemunitdir)
+TMPFILES:=$(DESTDIR)$(shell pkg-config systemd --variable=tmpfilesdir)
+
+GNUTLS_CFLAGS:=$(shell pkg-config --cflags-only-I gnutls)
+GNUTLS_LIBS:=$(shell pkg-config --libs gnutls)
+AVAHI_CFLAGS:=$(shell pkg-config --cflags-only-I avahi-core)
+AVAHI_LIBS:=$(shell pkg-config --libs avahi-core)
+GPGME_CFLAGS:=$(shell gpgme-config --cflags; getconf LFS_CFLAGS)
+GPGME_LIBS:=$(shell gpgme-config --libs; getconf LFS_LIBS; \
 	getconf LFS_LDFLAGS)
-LIBNL3_CFLAGS=$(shell pkg-config --cflags-only-I libnl-route-3.0)
-LIBNL3_LIBS=$(shell pkg-config --libs libnl-route-3.0)
+LIBNL3_CFLAGS:=$(shell pkg-config --cflags-only-I libnl-route-3.0)
+LIBNL3_LIBS:=$(shell pkg-config --libs libnl-route-3.0)
 
 # Do not change these two
 CFLAGS+=$(WARN) $(DEBUG) $(FORTIFY) $(SANITIZE) $(COVERAGE) \
@@ -117,25 +117,25 @@
 	/usr/share/xml/docbook/stylesheet/nwalsh/xhtml/docbook.xsl \
 	$<; $(HTMLPOST) $@)
 # Fix citerefentry links
-HTMLPOST=$(SED) --in-place \
+HTMLPOST:=$(SED) --in-place \
 	--expression='s/\(<a class="citerefentry" href="\)\("><span class="citerefentry"><span class="refentrytitle">\)\([^<]*\)\(<\/span>(\)\([^)]*\)\()<\/span><\/a>\)/\1\3.\5\2\3\4\5\6/g'
 
-PLUGINS=plugins.d/password-prompt plugins.d/mandos-client \
+PLUGINS:=plugins.d/password-prompt plugins.d/mandos-client \
 	plugins.d/usplash plugins.d/splashy plugins.d/askpass-fifo \
 	plugins.d/plymouth
-PLUGIN_HELPERS=plugin-helpers/mandos-client-iprouteadddel
-CPROGS=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
-PROGS=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
-DOCS=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
+PLUGIN_HELPERS:=plugin-helpers/mandos-client-iprouteadddel
+CPROGS:=plugin-runner $(PLUGINS) $(PLUGIN_HELPERS)
+PROGS:=mandos mandos-keygen mandos-ctl mandos-monitor $(CPROGS)
+DOCS:=mandos.8 mandos-keygen.8 mandos-monitor.8 mandos-ctl.8 \
 	mandos.conf.5 mandos-clients.conf.5 plugin-runner.8mandos \
 	plugins.d/mandos-client.8mandos \
 	plugins.d/password-prompt.8mandos plugins.d/usplash.8mandos \
 	plugins.d/splashy.8mandos plugins.d/askpass-fifo.8mandos \
 	plugins.d/plymouth.8mandos intro.8mandos
 
-htmldocs=$(addsuffix .xhtml,$(DOCS))
-
-objects=$(addsuffix .o,$(CPROGS))
+htmldocs:=$(addsuffix .xhtml,$(DOCS))
+
+objects:=$(addsuffix .o,$(CPROGS))
 
 all: $(PROGS) mandos.lsm
 
@@ -325,6 +325,3 @@
 statedir:
 	install --directory statedir
 
-install: install-server install-client-nokey
-
-install-html: html

=== debian/changelog ===
mandos (1.7.17-1) unstable; urgency=medium

  * New upstream release.
  * Fix "fails with "LeakSanitizer has encountered a fatal error""
    by fixing memory leak in plugin-runner (Closes: #886595)
  * debian/control (Build-Depends): Also depend on "libgnutls28-dev (<<
    3.6.0) | libgnutls30 (<< 3.6.0)".
    (Package: mandos/Depends): - '' -
  * debian/compat: Change to "10".
  * debian/watch (version): Change to "4".
    (opts/pgpsigurlmangle): Remove.
    (opts/pgpmode): New; set to "auto".
    (URL): Change to "https://ftp.recompile.se/pub/@PACKAGE@/@PACKAGE@
    @ANY_VERSION@(?:\.orig)?@ARCHIVE_EXT@".
  * debian/copyright: Update copyright year to 2018.
  * debian/rules: Support the "noopt" and "parallel" DEB_BUILD_OPTIONS.
    (override_dh_fixperms-arch): Use the DEB_HOST_MULTIARCH
    variable directly instead of shelling out to "dpkg-architecture".
  * debian/control (Standards-Version): Update to "4.1.3".
    (Build-Depends): Change version of debhelper dependency to ">= 10".
  * debian/mandos.lintian-overrides
    (init.d-script-needs-depends-on-lsb-base): Change line number to "46".

 -- Teddy Hogeborn <teddy@recompile.se>  Sat, 10 Feb 2018 19:09:50 +0100

=== debian/rules ===
--- 
+++ 
@@ -1,4 +1,14 @@
 #!/usr/bin/make -f
+
+ifeq (,$(filter noopt,$(DEB_BUILD_OPTIONS)))
+    MAKEFLAGS += OPTIMIZE=-O0
+endif
+
+ifneq (,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+    NUMJOBS = $(patsubst parallel=%,%,$(filter parallel=%,$(DEB_BUILD_OPTIONS)))
+    MAKEFLAGS += -j$(NUMJOBS)
+endif
+
 %:
 	dh $@
 
@@ -23,8 +33,8 @@
 	dh_fixperms --exclude etc/keys/mandos \
 		--exclude etc/mandos/plugins.d \
 		--exclude etc/mandos/plugin-helpers \
-		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugins.d \
-		--exclude usr/lib/$(shell dpkg-architecture -qDEB_HOST_MULTIARCH 2>/dev/null)/mandos/plugin-helpers \
+		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugins.d \
+		--exclude usr/lib/$(DEB_HOST_MULTIARCH)/mandos/plugin-helpers \
 		--exclude usr/share/doc/mandos-client/examples/network-hooks.d
 	chmod --recursive g-w -- \
 	"$(CURDIR)/debian/mandos-client/usr/share/doc/mandos-client/examples/network-hooks.d"

## mandos 1.7.18

=== Makefile ===
--- 
+++ 
@@ -40,7 +40,7 @@
 OPTIMIZE:=-Os -fno-strict-aliasing
 LANGUAGE:=-std=gnu11
 htmldir:=man
-version:=1.7.17
+version:=1.7.18
 SED:=sed
 
 USER:=$(firstword $(subst :, ,$(shell getent passwd _mandos || getent passwd nobody || echo 65534)))

=== debian/changelog ===
mandos (1.7.18-1) unstable; urgency=medium

  * New upstream release.

 -- Teddy Hogeborn <teddy@recompile.se>  Mon, 12 Feb 2018 16:00:11 +0100
